/*
  Tvister - live status checker for JustinTV, Own3d, Regame, etc.
  Copyright(c) 2011 Ndragomirov[jdavid214@gmail.com]
  
  Dual licensed under the MIT and GPL licenses:
  http://www.opensource.org/licenses/mit-license.php
  http://www.gnu.org/licenses/gpl.html
  
*/

var defaults = {};

defaults.attr = {
	width : 640,
	height : 480
};

defaults.param = {
	wmode : 'opaque',
	bgcolor : '#000000',
	allowfullscreen : 'true',
	allowscriptaccess : 'always'
};

function createEmbed( attr ) {
	var objectAttrs = ' ';
	for ( var i in attr ) {
		objectAttrs += '{key} = "{value}" '.replace(/{key}/, i).replace(/{value}/, attr[i]);
	}

	return '<embed' + objectAttrs +'></embed>';
}

function createObject( attr, param ) {
	var objectParams = '',
		objectAttrs = ' ';
	
	for( var i in param ) {
		objectParams += '<param name="{key}" value="{value}" />'.replace(/{key}/, i).replace(/{value}/, param[i]);
	};
	
	for ( var i in attr ) {
		objectAttrs += '{key} = "{value}" '.replace(/{key}/, i).replace(/{value}/, attr[i]);
	}
	
	return '<object' + objectAttrs +' >'+ objectParams + '</object>';
}


function create( objectOptions, embedOptions ) {
	
	var oAttr = mergeObjects(defaults.attr, objectOptions.attr),
		oParam = mergeObjects(defaults.param, objectOptions.param),
		eAttr,
		embed,
		obj;
	
	obj = createObject(oAttr, oParam);
	
	if (embedOptions) {
		eAttr = mergeObjects(defaults.param, defaults.attr, embedOptions.attr);
		embed = createEmbed(eAttr);
		console.log('embed', embed);
		obj = obj.replace(/<\/object>$/, embed);
	} 
	
	return obj;
}

function mergeObjects() {
	var objects = Array.prototype.slice.call(arguments, 0),
		result = {};
	
	objects.forEach(function(e) {
		result = mixin( result, e );
	});
	
	return result;
}

function mixin( obj, source ) {
	
	for( var i in source ) {
		if ( source.hasOwnProperty(i) ) {
			obj[i] = source[i];
		};
	};
	
	return obj;
}

module.exports.create = create;
module.exports.createEmbed = createEmbed;